using System;
using Jypeli;

/// @author  Antti-Jussi Lakanen, Vesa Lappalainen
/// @version 2025
///
/// <summary>
/// Ohjelma piirtää kuusi toisiaan sivuavaa palloa kolmion muotoon.
/// </summary>
public class T5_Lumilyhty : PhysicsGame
{
    /// <summary>
    /// Kutsutaan PiirraPalloa muutaman kerran.
    /// </summary>
    public override void Begin()
    {
        Level.Background.Color = Color.Black;
        double a = 25; // Pallon säde. Tämä on kolmion kateetti (vaakasuorassa)  
        double c = a * 2; // 2 * pallon säde. Tämä on kolmion hypotenuusa.
        double y = 0; // Alimman pallon y-koordinaatti. 
        double b = Math.Sqrt(c * c - a * a); // Pythagoras: a^2 = b^2 + c^2 --> b = sqrt(c*c - a*a)
        // Toinen tapa korottaa 2. potenssiin, Math.Pow(r2, 2);
        
        // alarivi
        PiirraPallo(-2 * a, y, a);
        PiirraPallo(0, y, a);
        PiirraPallo(2 * a, y, a);
       
        // keskirivi
        y = y + b;
        PiirraPallo(-a, y, a);
        PiirraPallo(+a, y, a);
        
        // ylin pallo
        y = y + b;
        PiirraPallo(0, y, a);

        Camera.ZoomToAllObjects(100);
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }

    /// <summary>
    /// Aliohjelma piirtää ruutuun yhden pallon, jonka
    /// säde on r, ja keskipiste on (x, y).
    /// </summary>
    /// <param name="x">Pallon keskipisteen x-koordinaatti.</param>
    /// <param name="y">Pallon keskipisteen y-koordinaatti.</param>
    /// <param name="r">Pallon säde</param>
    public void PiirraPallo(double x, double y, double r)
    {
        PhysicsObject pallo = new PhysicsObject(r * 2, r * 2, Shape.Circle);
        pallo.X = x;
        pallo.Y = y;
        Add(pallo);
    }
}
